/*This project aims at performing basic banking application.It enables user to add new customer information,to change the 
existing information,to perform appropriate transactions,to display the data of desired customer and so forth.To perform 
this various tasks ,our program uses different functions like
modification,addition,del,menu,search,display,view,transactions,check etc.*/

#include<fstream>//fstream provides an interface to read and write data from files as input/output streams.
#include<iostream>//The iostream library is an object-oriented library that provides input and output functionality using streams..
#include<cstdio>//Input and Output operations can also be performed in C++ using the C  Standard Input and Output Library named cstdio.
#include<cstring>//This header file defines several functions to manipulate C strings  and arrays.

#define interest_rate  0.000136986	//interest_rate = 0.05/365

using namespace std;
int accno;
int test();
int returnaccno();
int assignactno();


class bank
{
	   	long actno;
		char name[30];
		long phone;
		float balance;	
		int age;
	   	int dob[3];//This array stores date of birth of a customer.
		char fname[30];//This character array stores name of father of the customer.
		char address[50];
		char emailadd[25];
	   	int base_date[3];

	public:
	bank()
	{
		name[0]='\0';
		balance=0;
		age=0;
	}

	   	void modification();// //This function will be used to modify the filled data if necessary.
		void addition();////This function will add new customer to the database file.
		void del();//This function will be used to delete an account .
	   	void menu();//This function displays the main menu of the bank. 
		void search();//This function checks whether given account exists or not?and returns the position of that account.
		void getdata();//This function is used to take input data from the user.
		void display();//This function displays the desired record.
		void view(int);//This function is also used to display the record of customer.
		void transaction(int);//This function performs basic transaction operations and modifies given balance accordingly.	
		char check(char *);
	   	void interest();//This function calculates the interest over balance for the given time period.
		int  verify_transaction(float, float , short int);
		int compare_dates(int [],int []);
}obj;


void update(bank newrec, int n)  // To update an existing record in the database
{
	   int t=test();
	   int i=0;
	   ifstream f1;
	   f1.open("bank11.dat",ios::in|ios::binary);
	   bank* temp=new bank[t];                     // Dynamically created array
	   while(f1.read((char*)&obj,sizeof(obj)))
	   {
	      temp[i]=obj;
		   i++;
	   }
	   f1.close();
	   int pos=n-1001;
	   temp[pos]=newrec;
	   ofstream f2;
	   f2.open("bank11.dat",ios::out|ios::binary);
	   for(int j=0;j<t;j++)
	   {
		   obj=temp[j];
		   f2.write((char*)&obj,sizeof(obj));
	   }
	   f2.close();
	   delete temp;
}

	
int test()    //FIND NO. OF RECORDS
{
	   int n=returnaccno()-1000;  
	   return n ;
}
	
	
int returnaccno()//a1.txt stores the account number of the last customer.this function returns that account number.	
{
	   ifstream fin;
	   fin.open("a1.txt");
	   int accno;
	   fin>>accno;
	   fin.close();
	   return accno;
}
/*Whenever a customer is to be added in the record following function assigns that customer a account number which is greater by one than the last.It also writes that new account number in a1.txt*/
	
int assignactno()
{
	   ifstream fin;
	   ofstream fout;
	   fin.open("a1.txt");
	   int accno;
	   fin>>accno;
	   int newac=accno+1;
	   fin.close();
	   fout.open("a1.txt");
	   fout<<newac;
	   fout.close();
	   return newac;
}
	
void bank::addition()  //ADDING  INFORMATION
{
	   ofstream fout;
		getdata();
		fout.open("bank11.dat",ios::app|ios::binary);
		cout<<"ENTER AMOUNT TO BE DEPOSITED"<<endl;
      firstdep:      
	   cin>>obj.balance;
	   if(obj.balance < 1000)
	   {
		   cout<<"PLEASE ENTER MORE THAN 1000"<<endl;
		   goto firstdep;
	   }      
	   fout.write((char*)&obj,sizeof(obj));
	   fout.close();
	   cout<<"\n\nNEW ACCONT CREATED SUCCESSFULLY";
	   view(obj.actno);
	   char ch = cin.get();	
}
 

void bank::getdata()//This function is used to add a new customer in the existing database .It takes whole information from the user and stores it .   
{
	   system("clear");
		char ch;
		char tmp[100];
	   cout<<" [ADDITION] ";
		obj.actno=assignactno();
		cout<<" \n ENTER NAME : ";
		cin.getline(obj.name,30,'\n');
		cout<<"\n ENTER YOUR DATE OF BIRTH ( YYYY - DD - MM) :";
	   cin>>dob[0]; 
      testdob:   //checks validity of the entered date since it can not be more than 31.   
	   cin>>dob[2];
	   if (dob[2] > 31)
	   {
         cout<<"PLEASE RE-ENTER DATE";   
		   goto testdob;
		}
      testmob:      
		cin>>dob[1];
		cin.get(ch);
		if (dob[1] >12)//since month can not be more than 12. 
		{
		   cout<<"PLEASE RE-ENTER MONTH-";
			goto testmob;
		}
		cout<<" \n ENTER FATHER's NAME : ";
		cin.getline(obj.fname,30,'\n');      
		cout<<" \n ENTER PHONE NUMBER : ";
      testphone:      
		cin>>obj.phone;
		sprintf(tmp,"%l",obj.phone);
		if(strlen(tmp) >11)
		{
			cout<<"PLEASE RE-ENTER PHONE NUMBER";
			goto testphone;
		} 
		cin.get(ch);
		cout<<" \n ENTER HOUSE ADDRESS : ";
		cin.getline(obj.address,50,'\n');
		cout<<" \n ENTER EMAIL ADDRESS : ";
		cin.getline(obj.emailadd,25,'\n');
	   obj.balance=0;
      {
				char temp[10];
				FILE *fp;
				system("date --rfc-3339 date>a.txt");
				fp = fopen("a.txt","r");
				fgets(temp,10,fp);//in 'date' you get the system date
				fclose(fp);
				system("rm a.txt");

				int temp1[10];
				for(int i = 0 ; i<10 ; i++)
					temp1[i]=atoi(&temp[i]);
				obj.base_date[0]= (temp1[0])*1000 + (temp1[1])*100 + (temp1[2]) *10 + (temp1[3]);
				obj.base_date[1]= (temp1[5])*10 + (temp1[6]);
				obj.base_date[2]= (temp1[8])*10 + (temp1[9]);
	   }
}

	
void bank::display() //Whenever this function is called ,it shows complete record of the desired customer.
{
	   system("clear");
		cout<<"\n";
		cout<<" ACCOUNT NO:"<<obj.actno<<"\n";
		cout<<" NAME : "<<obj.name<<"\n";
	   cout<<" DATE OF BIRTH(YYYY-DD-MM) : "<<obj.dob[0]<<"-"<<obj.dob[2]<<"-"<<obj.dob[1]<<"\n";
	   cout<<" BALANCE  :"<<obj.balance<<"\n";	
		cout<<" FATHER'S NAME: "<<obj.fname<<"\n";
		cout<<" PHONE NUMBER : "<<obj.phone<<"\n";
		cout<<" HOUSE ADDRESS : "<<obj.address<<"\n";
		cout<<" EMAIL ADDRESS : "<<obj.emailadd<<"\n";
		char ch,ch1;
	   cin.get(ch);
	   cin.get(ch1);		
}

	
void bank:: transaction(int n)  // Makes the transaction and updates the record
{
	   char ch1,ch2;
		system("clear");
		ifstream f1;
		f1.open("bank11.dat",ios::in|ios::binary);
		int pos=n-1000;
		f1.seekg((pos-1)*sizeof(obj),ios::beg);
		f1.read((char*)&obj,sizeof(obj));
		f1.close();
		if(obj.name[0]=='\0')//The name of the deleted customer is assigned as '\0'. 
		{
			char ch1;
			cout<<"\n THIS ACCOUNT HAS BEEN DELETED";
			ch1=cin.get();
			return;
		}
	   int ch,flag;
		float amount;
		if (obj.balance==0)
			ch=2;
		else
		{			
				cout<<"ENTER YOUR CHOICE"<<endl<<"1-WITHDRAWAL 2-DEPOSIT"<<endl;
				cin>>ch;
		}
	   switch(ch)
	   {		
		   case 1:	re_withdraw:
			   cout<<"ENTER THE AMOUNT TO BE WITHDRAWAN(ENTER 0 TO EXIT) :";
			   cin>>amount;
			   if(amount == 0)
				   return;
			   flag= verify_transaction(obj.balance,amount,ch);				
			   if(flag == 1)
			   {
				   obj.balance-=amount;
				   cout<<endl<<"COLLECT YOUR CASH";
				   cout<<"\n THE BALANCE AVAILIABLE IS "<<obj.balance<<endl;
               ch1=cin.get();
				   ch2=cin.get();
			   }
			   else if(flag == 2)
			   {
				   cout<<endl<<"INSUFFICIENT BALANCE . MINIMUM BALANCE SHOULD BE 1000 AND MAXIMUM TRANSACTION SHULD BE 50000"<<endl;
				   ch1=cin.get();
				   ch2=cin.get();
				   goto re_withdraw;
			   }
			   break;
			   
		   case 2:     re_deposit:
			   cout<<"ENTER AMOUNT TO DE DEPOSITED(ENTER 0 TO EXIT):";
			   cin>>amount;
			   if(amount == 0)
			      return;
			   flag = verify_transaction(obj.balance,amount,ch);
			   if (flag==1)
			   {				
						       
			       obj.balance+=amount;
			       cout<<endl<<"THE AVAILIABLE BALANCE IS:"<<obj.balance<<endl;
			       ch1=cin.get();
			       ch2=cin.get();
			   }
			   else if(flag ==2)
			   {
			       cout<<"INVALID TRANSACTION . MAXIMUM TRANSACTION SHOULD BE 50000"<<endl;
			       ch1=cin.get();
			       ch2=cin.get();
			       goto re_deposit;
						       
			   }
			   break;
		      default:cout<<"\nINVALID CHOICE \n\n\n\n";
	   } 
	   update(obj,n);
		
}

	
int bank :: verify_transaction(float balance, float transaction_amount, short int command) 
{
	if(command == 1 || command ==2)
	{	//checking for transaction bounds.
		if(transaction_amount<=50000.00)
		{			
				//checking for withdrawal.
				if(command==1)
				{					
						if(balance-transaction_amount>1000)
							return 1;								
						else
							return 2;
				}			
				//for deposit.
				else if(command==2)					
						return 1;
		}		
		else			
				return 2;
	}
	else
		return 2;
}

	
void bank::modification() //TO MODIFY ANY DATA IN  THE RECORD IF NECESSARY
{
	   char tmp[25];
		system("clear");
		cout<<" [ MODIFICATION ] ";
		int pn;
		int i;
		ofstream fout;
		ifstream fin; 
		int n=test();
		if(n==0)
		{
			cout<<"\n FILE IS EMPTY ! ";
			return;
		}
	
		char ch;
		cout<<"\n ENTER ACCOUNT NO. :";
		cin>>pn;
		ch=cin.get();
		int pos;
		pos=pn-1000;	
		if(pn>returnaccno())
		{
			char ch;
			cout<<"\n SUCH A RECORD DOES NOT EXIST";
			cin.get(ch);	
			return;
		}
	   fin.seekg((pos-1)*sizeof(obj),ios::beg);
	   fin.read((char*)&obj,sizeof(obj));	     
		fin.close();
	   if(obj.name[0]=='\0')
	   {
		   char ch;
		   cout<<"\n THIS ACCOUNT HAS BEEN DELETED";
		   ch=cin.get();
		   return;
	   }
	   if(check("NAME")=='y')
	   {
		   cout<<"\n ENTER NEW NAME : ";
			cin.getline(obj.name,30,'\n');
	   }
	   if(check("FATHER'S NAME")=='y')
	   {
		   cout<<"\n ENTER NEW FATHER’S NAME :";
			cin.getline(obj.fname,30,'\n');
	   }
	   if(check("PHONE NUMBER")=='y')
	   {
		   cout<<"\n ENTER NEW PHONE NUMBER :";
			testphone1:      
			cin>>obj.phone;
		   sprintf(tmp,"%l",obj.phone);
			if(strlen(tmp) >11)
			{
			   cout<<"PLEASE RE-ENTER PHONE NUMBER";
			   goto testphone1;
			} 
			   cin.get(ch);
	   }
	
		if(check("HOME ADDRESS")=='y')
		{
			cout<<"\n ENTER NEW ADDRESS :";
			cin.getline(obj.address,50,'\n');
		}
	   if(check("EMAIL ADDRESS:")=='y')
	   {
		   cout<<"\n ENTER NEW MAIL ADDRESS :";
			cin.getline(obj.emailadd,25,'\n');
	   }

	   update(obj,pn);
      cout<<"THE RECORD HAS BEEN UPDATED . PRESS ANY KEY TO VIEW THE RECORD";
	   ch=cin.get();
	   view(pn);  
}


char bank::check(char *s)//Whenever user want to modify something this function function ensures from him whether he wants to do so or not.
{
	   cout<<"\n MODIFY \t "<<s<<"\t"<<"Y/N";
		char ch;
		cin>>ch;
	   char ch1;
	   ch1=cin.get();
		if((ch=='y')||(ch=='Y'))
			return 'y';
		else
			return 'n';
}


void bank::search()//The function searches the desired account in the database file and shows its position.
{
	   system("clear");
	   int t=test();
		if(t==0)
		{       char ch;
			cout<<"\n FILE IS EMPTY ! ";
			ch=cin.get();
			return;
		}
	   cout<<"ENTER ACCOUNT NUMBER TO BE SEARCHED:";
	   int n;
	   cin>>n;
	   if(n>returnaccno())
	   {
		   char ch,ch1;
		   cout<<"\n SUCH A RECORD DOES NOT EXIST";
		   cin.get(ch);
		   cin.get(ch1);	
		   return;
	   }
	   int pos=n-1000;
	   view(pos);
	   return;
}


void bank::view(int pos)//The function displays any record of given position. 
{
	   ifstream f;
	   f.open("bank11.dat", ios::in| ios::binary);
	   f.seekg((pos-1)*sizeof(obj),ios::beg);
	   f.read((char*)&obj,sizeof(obj));
	   if(obj.name[0]=='\0')
	   {
		   char ch,ch1;
		   cout<<"\n THIS ACCOUNT HAS BEEN DELETED.";
		   ch=cin.get();
		   ch1=cin.get();
		   return;
	   }
	   display();
	   return;
}


void bank::del()//The function deletes desired account and makes appropriate changes in important variables .
{
	   system("clear");
	   cout<<"\nENTER THE ACCOUNT NUMBER:";
	   int n;
	   cin>>n;
	   int pos=n-1000;
	   char ch,ch1,ch2;
	   cout<<"\n ARE YOU SURE YOU WANT TO DELETE THE ACCOUNT Y/N";
	   view(pos);
	   if(obj.name[0]=='\0')
	   {
		   char ch;
		   cout<<"\n THIS ACCOUNT HAS ALREADY BEEN DELETED";
		   ch=cin.get();
		   return;
	   }
	   cin>>ch;
	   if (ch=='y'||ch=='Y')
	   {
		   obj.name[0]='\0';
		   cout<<"THE ACCOUNT IS DELETED \n THE AVAILIABLE BALANCE WAS "<<obj.balance;
		   obj.balance=0;
		   ch1=cin.get();
		   ch2=cin.get();
	   }
	   update(obj,n);
}


void  bank::menu() 
{
	   char ch,ch1;
	   system("clear");

	   cout<<"\t \n\t    A:ADDITION \n  ";

	   cout<<"\t    M:MODIFICATION \n  ";

	   cout<<"\t    S:SEARCH \n  ";

	   cout<<"\t    T:TRANSACTION  \n  ";

	   cout<<"\t    D:DELETION \n   ";

	   cout<<"\t    E:EXIT \n  ";

	   cout<<"\n\n\n\t PRESS CTRL+C TO EXIT AT ANY TIME"<<endl;

	   cin>>ch;

	   cin.get(ch1);
	   switch(ch)
	   {
		   case 'a':
		   case 'A':
			   addition();
			   break;
			   
		   case 'd' :
		   case 'D' :
			   del();
			   break;
			   
		   case 't':
		   case'T':
			   cout<<"\nENTER THE ACCOUNT NUMBER:";
			   int n;
			   cin>>n;
			   if(n>returnaccno())
			   {
				   char ch,ch1;
				   cout<<"\n SUCH A RECORD DOES NOT EXIST.";
				   cin.get(ch);
				   cin.get(ch1);	
				   break;
			   }
			   transaction(n);
			   break;
			   
		   case 'm':
		   case 'M':
			   modification();
			   break;

		   case 's':
		   case 'S':
			   search();
			   break;
			   
		   case 'e':
		   case 'E':
			   system("clear");
			   exit(0);
			   break;
		   default:cout<<"INVALD CHOICE \n\n\n\n";
	   }
}

void bank::interest()//The function calculates interest over balance of the customer.
{
	   char temp[10];
		FILE *fp;
		system("date --rfc-3339 date>a.txt");//system gives current date which is stored in a.txt
		fp = fopen("a.txt","r");
		fgets(temp,10,fp);//date is read and stored in temp as a character array.
	   fclose(fp);
		system("rm a.txt");
		int temp1[10];
	   for(int i = 0 ; i<10 ; i++)
		   temp1[i]=atoi(&temp[i]);	
		int current_date[3];
		current_date[0]= (temp1[0])*1000 + (temp1[1])*100 + (temp1[2]) *10 + (temp1[3]);//year is converted into a four digit number and stored in current_date array . 
		current_date[1]= (temp1[5])*10 + (temp1[6]);//month is converted into a number and stored in current_date array . 
		current_date[2]= (temp1[8])*10 + (temp1[9]);//date is converted into a  number and stored in current_date array . 
				
		fstream f;
		f.open("bank11.dat",ios::in|ios::binary);
		while(f.read((char*)&obj,sizeof(obj)))
		{
			   int flag = compare_dates(current_date , obj.base_date);              
				float temp_int = (obj.balance*interest_rate)*flag;         
			   obj.balance += temp_int;
				obj.base_date[0]=current_date[0];
				obj.base_date[1]=current_date[1];
				obj.base_date[2]=current_date[2];
								
				if(current_date[1]==dob[1] && current_date[2]==dob[2]) //age increment done in interest decrease the number of processes.
					obj.age=current_date[0]-obj.dob[0];
			   update(obj,obj.actno);
		}
}
int bank ::  compare_dates(int current_date[], int base_date[])
{
	   char temp[10];
		FILE *fp;
		system("date --rfc-3339 date>a.txt");
		fp = fopen("a.txt","r");
		fgets(temp,10,fp);//in 'date' you get the system date
	   fclose(fp);
		system("rm a.txt");
		int temp1[10];
	   for(int i = 0 ; i<10 ; i++)
		   temp1[i]=atoi(&temp[i]);	
		int current_date1[3];
		current_date1[0]= (temp1[0])*1000 + (temp1[1])*100 + (temp1[2]) *10 + (temp1[3]);
		current_date1[1]= (temp1[5])*10 + (temp1[6]);
		current_date1[2]= (temp1[8])*10 + (temp1[9]);
				
		int d;
		if(current_date1[1]==base_date[1])
		{
			d=current_date1[2]-base_date[2];
			return d;
		}
		else if(base_date[1]==1 || base_date[1]==3 || base_date[1]==5 || base_date[1]==7 || base_date[1]==8 || base_date[1]==10 || base_date[1]==12)
		{
			d=current_date1[2]+31-base_date[2];
			return d;
		}
		else if(base_date[1]==2 && base_date[0]%4 != 0)
		{
			d=current_date1[2]+28-base_date[2];
			return d;
		}	
		else if(base_date[1]==4 || base_date[1]==6 || base_date[1]==9 || base_date[1]==11)
		{
			d=current_date1[2]+30-base_date[2];
			return d;
		}
		else if(base_date[1]==2 && base_date[0]%4 == 0)
		{
			d=current_date1[2]+29-base_date[2];
			return d;
		}
}


int main()
{
	obj.interest();
	cout<<"\n\n\t\tWelcome to the Banking System"<<endl<<endl;
	for(;;)
	{
	   obj.menu();
	}
	return 0;
}

